﻿package 
{
    import fl.controls.*;
    import flash.display.*;
    import flash.events.*;
    import flash.filters.*;
    import flash.geom.*;
    import flash.text.*;

    public class Plot extends MovieClip {
        public const padding:int = 20;
        public var starHolder:Sprite;
        public var XAxisLabelHolder:Sprite;
        public var YAxisLabelHolder:Sprite;
        public var XAxisTickmarckHolder:Sprite;
        public var YAxisTickmarckHolder:Sprite;
        public var MassLabelHolder:Sprite;
        private var maxMass:Number = 31.47;
        private var maxLuminosity:Number;
        private var maxLifetime:Number;
        private var minMass:Number = 0.11;
        private var minLuminosity:Number;
        private var minLifetime:Number;
        public var YAxisMaxLabel:TextField;
        public var YAxisMinLabel:TextField;
        public var XAxisMaxLabel:TextField;
        public var XAxisMinLabel:TextField;
        public var YAxisMaxExponentLabel:TextField;
        public var YAxisMinExponentLabel:TextField;
        public var XAxisMaxExponentLabel:TextField;
        public var XAxisMinExponentLabel:TextField;
        public var MassLabel:TextField;
        public var targetTimelineLabelHolder:Sprite;
        public var targetGraphArea:MovieClip;
        public var targetTimelineSlider:Slider;
        public var targetTimeline:Timeline;
        public var targetVerticalAxis:ComboBox;
        public var targetHorizontalAxis:ComboBox;
        public var targetStarManager:StarManager;
        public var graphHeight:int;
        public var graphWidth:int;
        public var tickmarksX:Sprite;
        public var tickmarksY:Sprite;
        public var XAxisMassLabels:TextField;
        public var XAxisLumLabels:TextField;
        public var XAxisLifeLabels:TextField;
        public var YAxisMassLabels:TextField;
        public var YAxisLumLabels:TextField;
        public var YAxisLifeLabels:TextField;
        public var glowFilter:GlowFilter;
        public var XAxisUnitLabel:TextField;
        public var YAxisUnitLabel:TextField;

        public function Plot(param1:MovieClip, param2:ComboBox, param3:ComboBox, param4:StarManager, param5:Timeline) {
            this.maxLuminosity = Math.pow(31.47, 3.5);
            this.maxLifetime = Math.pow(0.11, -2.5);
            this.minLuminosity = Math.pow(0.11, 3.5);
            this.minLifetime = Math.pow(31.47, -2.5);
            this.glowFilter = new GlowFilter(16777215, 0.5);
            this.targetGraphArea = param1;
            this.targetVerticalAxis = param2;
            this.targetHorizontalAxis = param3;
            this.targetStarManager = param4;
            this.targetTimeline = param5;
            this.graphHeight = this.targetGraphArea.graphAreaInside.height;
            this.graphWidth = this.targetGraphArea.graphAreaInside.width;
            this.MassLabelHolder = new Sprite();
            this.MassLabel = new TextField();
            this.YAxisLabelHolder = new Sprite();
            this.targetGraphArea.addChild(this.YAxisLabelHolder);
            this.XAxisLabelHolder = new Sprite();
            this.targetGraphArea.addChild(this.XAxisLabelHolder);
            this.tickmarksX = new Sprite();
            this.XAxisTickmarckHolder = new Sprite();
            this.targetGraphArea.graphAreaInside.addChild(this.XAxisTickmarckHolder);
            this.tickmarksY = new Sprite();
            this.YAxisTickmarckHolder = new Sprite();
            this.targetGraphArea.graphAreaInside.addChild(this.YAxisTickmarckHolder);
            this.removeEventListener(Event.ENTER_FRAME, this.targetTimeline.frameHandler);
            this.starHolder = new Sprite();
            this.targetGraphArea.addChild(this.starHolder);
            this.targetVerticalAxis.addEventListener(Event.CHANGE, this.placeStars);
            this.targetHorizontalAxis.addEventListener(Event.CHANGE, this.placeStars);
            this.targetVerticalAxis.addEventListener(Event.CHANGE, this.verticalLabelChanged);
            this.targetHorizontalAxis.addEventListener(Event.CHANGE, this.horizontalLabelChanged);
            return;
        }
        public function placeStars(param1:Event) {
            var _loc_5:MovieClip;
            var _loc_2:* = this.targetGraphArea.graphAreaInside.height;
            var _loc_3:* = this.targetGraphArea.graphAreaInside.width;
            this.clearObject(this.starHolder);
            var _loc_4:int;
            while (_loc_4 < this.targetStarManager.selectedStars.length){
                // label
                this.targetStarManager.selectedStars[_loc_4].filters = new Array();
                this.targetStarManager.selectedStars[_loc_4].alpha = 0.75;
                this.targetStarManager.selectedStars[_loc_4].width = 30;
                this.targetStarManager.selectedStars[_loc_4].height = 30;
                _loc_5 = this.targetStarManager.selectedStars[_loc_4];
                switch(this.targetVerticalAxis.selectedItem.label){
                    case "Luminosity":{
                        _loc_5.y = this.returnLumXY(_loc_5.luminosity).y - _loc_5.height / 2;
                        break;
                    }
                    case "Lifetime":{
                        _loc_5.y = this.returnLifeXY(_loc_5.lifetime).y - _loc_5.height / 2;
                        break;
                    }
                    case "Mass":{
                        _loc_5.y = this.returnMassXY(_loc_5.mass).y - _loc_5.height / 2;
                        break;
                    }
                    default:{
                        break;
                        break;
                    }
                }
                switch(this.targetHorizontalAxis.selectedItem.label){
                    case "Luminosity":{
                        _loc_5.x = this.returnLumXY(_loc_5.luminosity).x;
                        break;
                    }
                    case "Lifetime":{
                        _loc_5.x = this.returnLifeXY(_loc_5.lifetime).x;
                        break;
                    }
                    case "Mass":{
                        _loc_5.x = this.returnMassXY(_loc_5.mass).x;
                        break;
                    }
                    default:{
                        break;
                        break;
                    }
                }
                this.starHolder.addChild(_loc_5);
                _loc_5.addEventListener(MouseEvent.MOUSE_OVER, this.showMass);
                _loc_5.addEventListener(MouseEvent.MOUSE_OUT, this.hideMass);
                _loc_4++;
            }
            return;
        }
        private function verticalLabelChanged(param1:Event) {
            var _loc_2:BitmapData;
            var _loc_3:Bitmap;
            var _loc_4:*;
            var _loc_5:int;
            var _loc_6:Number;
            var _loc_7:int;
            var _loc_8:int;
            var _loc_9:Number;
            var _loc_10:Number;
            var _loc_11:int;
            switch(this.targetVerticalAxis.selectedItem.label){
                case "Luminosity":{
                    this.clearObject(this.YAxisLabelHolder);
                    this.YAxisMaxLabel = this.createLabel(this.decToSci(this.maxLuminosity)[0], 16, 16777215);
                    this.YAxisMaxLabel.y = 1;
                    this.YAxisMaxLabel.x = -90;
                    this.YAxisLabelHolder.addChild(this.YAxisMaxLabel);
                    this.YAxisMaxExponentLabel = this.createLabel(this.decToSci(this.maxLuminosity)[1], 11, 16777215);
                    this.YAxisMaxExponentLabel.y = -8;
                    this.YAxisMaxExponentLabel.x = -23;
                    this.YAxisLabelHolder.addChild(this.YAxisMaxExponentLabel);
                    this.YAxisMinLabel = this.createLabel(this.decToSci(this.minLuminosity)[0], 16, 16777215);
                    this.YAxisMinLabel.y = 520;
                    this.YAxisMinLabel.x = -90;
                    this.YAxisLabelHolder.addChild(this.YAxisMinLabel);
                    this.YAxisMinExponentLabel = this.createLabel(this.decToSci(this.minLuminosity)[1], 11, 16777215);
                    this.YAxisMinExponentLabel.y = 510;
                    this.YAxisMinExponentLabel.x = -20;
                    this.YAxisLabelHolder.addChild(this.YAxisMinExponentLabel);
                    this.YAxisUnitLabel = this.createLabel("Solar Luminosities", 18, 16777215);
                    _loc_2 = new BitmapData(this.YAxisUnitLabel.width, this.YAxisUnitLabel.height, true, 0);
                    _loc_2.draw(this.YAxisUnitLabel);
                    _loc_3 = new Bitmap(_loc_2);
                    _loc_3.smoothing = true;
                    _loc_3.rotation = -90;
                    _loc_3.y = 270;
                    _loc_3.x = -105;
                    this.YAxisLabelHolder.addChild(_loc_3);
                    this.tickmarksY.graphics.clear();
                    this.tickmarksY.graphics.beginFill(16777215);
                    this.tickmarksY.graphics.lineStyle(2, 16777215);
                    _loc_4 = 8;
                    _loc_7 = 0;
                    while (_loc_7 < _loc_4){
                        // label
                        if (_loc_7 != 0 && _loc_7 != _loc_4--){
                            this.tickmarksY.graphics.moveTo(5, -this.returnLumTicmarckY(this.maxLuminosity - _loc_7 / _loc_4-- * (this.maxLuminosity - this.minLuminosity)));
                            this.tickmarksY.graphics.lineTo(-5, -this.returnLumTicmarckY(this.maxLuminosity - _loc_7 / _loc_4-- * (this.maxLuminosity - this.minLuminosity)));
                            this.YAxisLumLabels = this.createLabel(this.decToSciMinusExp(this.maxLuminosity - _loc_7 / _loc_4-- * (this.maxLuminosity - this.minLuminosity)) + "<Font Face= \'Century Gothic Superscript\'>" + this.decToExp(this.maxLuminosity - _loc_7 / _loc_4-- * (this.maxLuminosity - this.minLuminosity)) + "</Font>", 16, 16777215);
                            this.YAxisLumLabels.y = this.graphHeight - this.returnLumTicmarckY(this.maxLuminosity - _loc_7 / _loc_4-- * (this.maxLuminosity - this.minLuminosity)) - 28;
                            this.YAxisLumLabels.x = -85;
                            this.YAxisLabelHolder.addChild(this.YAxisLumLabels);
                        }
                        _loc_7++;
                    }
                    this.tickmarksY.x = 0;
                    this.tickmarksY.y = this.targetGraphArea.graphAreaInside.height - 17;
                    this.tickmarksY.graphics.endFill();
                    this.YAxisTickmarckHolder.addChild(this.tickmarksY);
                    break;
                }
                case "Lifetime":{
                    this.clearObject(this.YAxisLabelHolder);
                    this.YAxisMaxLabel = this.createLabel(this.decToSci(this.maxLifetime)[0], 16, 16777215);
                    this.YAxisMaxLabel.y = 1;
                    this.YAxisMaxLabel.x = -90;
                    this.YAxisLabelHolder.addChild(this.YAxisMaxLabel);
                    this.YAxisMaxExponentLabel = this.createLabel(this.decToSci(this.maxLifetime)[1], 11, 16777215);
                    this.YAxisMaxExponentLabel.y = -8;
                    this.YAxisMaxExponentLabel.x = -23;
                    this.YAxisLabelHolder.addChild(this.YAxisMaxExponentLabel);
                    this.YAxisMinLabel = this.createLabel(this.decToSci(this.minLifetime)[0], 16, 16777215);
                    this.YAxisMinLabel.y = 520;
                    this.YAxisMinLabel.x = -90;
                    this.YAxisLabelHolder.addChild(this.YAxisMinLabel);
                    this.YAxisMinExponentLabel = this.createLabel(this.decToSci(this.minLifetime)[1], 11, 16777215);
                    this.YAxisMinExponentLabel.y = 510;
                    this.YAxisMinExponentLabel.x = -20;
                    this.YAxisLabelHolder.addChild(this.YAxisMinExponentLabel);
                    this.YAxisUnitLabel = this.createLabel("Solar Lifetimes", 18, 16777215);
                    _loc_2 = new BitmapData(this.YAxisUnitLabel.width, this.YAxisUnitLabel.height, true, 0);
                    _loc_2.draw(this.YAxisUnitLabel);
                    _loc_3 = new Bitmap(_loc_2);
                    _loc_3.smoothing = true;
                    _loc_3.rotation = -90;
                    _loc_3.y = 225;
                    _loc_3.x = -105;
                    this.YAxisLabelHolder.addChild(_loc_3);
                    this.tickmarksY.graphics.clear();
                    this.tickmarksY.graphics.beginFill(16777215);
                    this.tickmarksY.graphics.lineStyle(2, 16777215);
                    _loc_5 = 8;
                    _loc_6 = Math.pow(10, _loc_5);
                    _loc_8 = 0;
                    while (_loc_8 < _loc_5){
                        // label
                        if (_loc_8 != 0 && _loc_8 != _loc_5 && _loc_8 != 1 && _loc_8 != 2){
                            _loc_9 = Math.pow(10, _loc_8);
                            _loc_10 = _loc_9 / _loc_6 * (this.maxLifetime - this.minLifetime);
                            this.tickmarksY.graphics.moveTo(5, -this.returnLifeTicmarckY(_loc_10));
                            this.tickmarksY.graphics.lineTo(-5, -this.returnLifeTicmarckY(_loc_10));
                            if (_loc_8 != _loc_5){
                                if (_loc_8 == 6){
                                    this.YAxisLifeLabels = this.createLabel("         " + String(24.9), 16, 16777215);
                                }
                                else if (_loc_8 == 7){
                                    this.YAxisLifeLabels = this.createLabel("        " + String(249.1), 16, 16777215);
                                }
                                else{
                                    this.YAxisLifeLabels = this.createLabel(this.decToSciMinusExp(_loc_10).substr(0, 11) + "<Font Face= \'Century Gothic Superscript\'>" + this.decToExp(_loc_10) + "</Font>", 16, 16777215);
                                }
                                this.YAxisLifeLabels.y = this.graphHeight - this.returnLifeTicmarckY(_loc_10) - 28;
                                trace(-this.returnLifeTicmarckY(_loc_10));
                                this.YAxisLifeLabels.x = -100;
                                this.YAxisLifeLabels.autoSize = TextFieldAutoSize.RIGHT;
                                this.YAxisLabelHolder.addChild(this.YAxisLifeLabels);
                            }
                        }
                        _loc_8++;
                    }
                    this.tickmarksY.x = 0;
                    this.tickmarksY.y = this.targetGraphArea.graphAreaInside.height - 17;
                    this.tickmarksY.graphics.endFill();
                    this.YAxisTickmarckHolder.addChild(this.tickmarksY);
                    break;
                }
                case "Mass":{
                    this.clearObject(this.YAxisLabelHolder);
                    this.YAxisMinLabel = this.createLabel(String(this.minMass), 16, 16777215);
                    this.YAxisMinLabel.y = 500;
                    this.YAxisMinLabel.x = -50;
                    this.YAxisLabelHolder.addChild(this.YAxisMinLabel);
                    this.YAxisUnitLabel = this.createLabel("Solar Masses", 18, 16777215);
                    _loc_2 = new BitmapData(this.YAxisUnitLabel.width, this.YAxisUnitLabel.height, true, 0);
                    _loc_2.draw(this.YAxisUnitLabel);
                    _loc_3 = new Bitmap(_loc_2);
                    _loc_3.smoothing = true;
                    _loc_3.rotation = -90;
                    _loc_3.y = 310;
                    _loc_3.x = -80;
                    this.YAxisLabelHolder.addChild(_loc_3);
                    this.tickmarksY.graphics.clear();
                    this.tickmarksY.graphics.beginFill(16777215);
                    this.tickmarksY.graphics.lineStyle(2, 16777215);
                    _loc_11 = 0;
                    while (_loc_11 < 7){
                        // label
                        if (_loc_11 != 0){
                            this.tickmarksY.graphics.moveTo(5, this.returnMassTicmarckY(5 * (-_loc_11)));
                            this.tickmarksY.graphics.lineTo(-5, this.returnMassTicmarckY(5 * (-_loc_11)));
                            this.YAxisMassLabels = this.createLabel(String(5 * _loc_11), 16, 16777215);
                            this.YAxisMassLabels.y = this.graphHeight - this.returnMassTicmarckY(5 * _loc_11) - 28;
                            this.YAxisMassLabels.x = -40;
                            this.YAxisLabelHolder.addChild(this.YAxisMassLabels);
                        }
                        _loc_11++;
                    }
                    this.tickmarksY.x = 0;
                    this.tickmarksY.y = this.targetGraphArea.graphAreaInside.height - 17;
                    this.tickmarksY.graphics.endFill();
                    this.YAxisTickmarckHolder.addChild(this.tickmarksY);
                    break;
                }
                default:{
                    break;
                }
            }
            return;
        }
        private function horizontalLabelChanged(param1:Event) {
            var _loc_2:int;
            var _loc_3:int;
            var _loc_4:Number;
            var _loc_5:int;
            var _loc_6:int;
            var _loc_7:Number;
            var _loc_8:Number;
            var _loc_9:int;
            switch(this.targetHorizontalAxis.selectedItem.label){
                case "Luminosity":{
                    this.clearObject(this.XAxisLabelHolder);
                    this.XAxisMaxLabel = this.createLabel(this.decToSci(this.maxLuminosity)[0], 16, 16777215);
                    this.XAxisMaxLabel.y = 540;
                    this.XAxisMaxLabel.x = 624;
                    this.XAxisLabelHolder.addChild(this.XAxisMaxLabel);
                    this.XAxisMaxExponentLabel = this.createLabel(this.decToSci(this.maxLuminosity)[1], 11, 16777215);
                    this.XAxisMaxExponentLabel.y = 536;
                    this.XAxisMaxExponentLabel.x = 694;
                    this.XAxisLabelHolder.addChild(this.XAxisMaxExponentLabel);
                    this.XAxisUnitLabel = this.createLabel("Solar Luminosities", 18, 16777215);
                    this.XAxisUnitLabel.y = 570;
                    this.XAxisUnitLabel.x = 240;
                    this.XAxisLabelHolder.addChild(this.XAxisUnitLabel);
                    this.tickmarksX.graphics.clear();
                    this.tickmarksX.graphics.beginFill(16777215);
                    this.tickmarksX.graphics.lineStyle(2, 16777215);
                    _loc_2 = 8;
                    _loc_5 = 0;
                    while (_loc_5 < _loc_2){
                        // label
                        if (_loc_5 != 0 && _loc_5 != _loc_2 && _loc_5 != 1){
                            this.tickmarksX.graphics.moveTo(this.returnLumXY(this.maxLuminosity - _loc_5 / _loc_2-- * (this.maxLuminosity - this.minLuminosity)).x, 5);
                            this.tickmarksX.graphics.lineTo(this.returnLumXY(this.maxLuminosity - _loc_5 / _loc_2-- * (this.maxLuminosity - this.minLuminosity)).x, -5);
                            this.XAxisLumLabels = this.createLabel(this.decToSciMinusExp(this.maxLuminosity - _loc_5 / _loc_2-- * (this.maxLuminosity - this.minLuminosity)) + "<Font Face= \'Century Gothic Superscript\'>" + this.decToExp(this.maxLuminosity - _loc_5 / _loc_2-- * (this.maxLuminosity - this.minLuminosity)) + "</Font>", 16, 16777215);
                            this.XAxisLumLabels.y = 540;
                            this.XAxisLumLabels.x = this.returnLumXY(this.maxLuminosity - _loc_5 / _loc_2-- * (this.maxLuminosity - this.minLuminosity)).x - 20;
                            this.XAxisLabelHolder.addChild(this.XAxisLumLabels);
                        }
                        _loc_5++;
                    }
                    this.tickmarksX.x = 17;
                    this.tickmarksX.y = this.graphHeight;
                    this.tickmarksX.graphics.endFill();
                    this.XAxisTickmarckHolder.addChild(this.tickmarksX);
                    break;
                }
                case "Lifetime":{
                    this.clearObject(this.XAxisLabelHolder);
                    this.XAxisMaxLabel = this.createLabel(this.decToSci(this.maxLifetime)[0], 16, 16777215);
                    this.XAxisMaxLabel.y = 540;
                    this.XAxisMaxLabel.x = 624;
                    this.XAxisLabelHolder.addChild(this.XAxisMaxLabel);
                    this.XAxisMaxExponentLabel = this.createLabel(this.decToSci(this.maxLifetime)[1], 11, 16777215);
                    this.XAxisMaxExponentLabel.y = 536;
                    this.XAxisMaxExponentLabel.x = 694;
                    this.XAxisLabelHolder.addChild(this.XAxisMaxExponentLabel);
                    this.XAxisMinLabel = this.createLabel(this.decToSci(this.minLifetime)[0], 16, 16777215);
                    this.XAxisMinLabel.y = 540;
                    this.XAxisMinLabel.x = -20;
                    this.XAxisLabelHolder.addChild(this.XAxisMinLabel);
                    this.XAxisMinExponentLabel = this.createLabel(this.decToSci(this.minLifetime)[1], 11, 16777215);
                    this.XAxisMinExponentLabel.y = 536;
                    this.XAxisMinExponentLabel.x = 49;
                    this.XAxisLabelHolder.addChild(this.XAxisMinExponentLabel);
                    this.XAxisUnitLabel = this.createLabel("Solar Lifetimes", 18, 16777215);
                    this.XAxisUnitLabel.y = 570;
                    this.XAxisUnitLabel.x = 240;
                    this.XAxisLabelHolder.addChild(this.XAxisUnitLabel);
                    this.tickmarksX.graphics.clear();
                    this.tickmarksX.graphics.beginFill(16777215);
                    this.tickmarksX.graphics.lineStyle(2, 16777215);
                    _loc_3 = 8;
                    _loc_4 = Math.pow(10, _loc_3);
                    _loc_6 = 0;
                    while (_loc_6 < _loc_3){
                        // label
                        if (_loc_6 != 0 && _loc_6 != _loc_3 && _loc_6 != 1 && _loc_6 != 2){
                            _loc_7 = Math.pow(10, _loc_6);
                            _loc_8 = _loc_7 / _loc_4 * (this.maxLifetime - this.minLifetime);
                            this.tickmarksX.graphics.moveTo(this.returnLifeXY(_loc_8).x, 5);
                            this.tickmarksX.graphics.lineTo(this.returnLifeXY(_loc_8).x, -5);
                            if (_loc_6 != _loc_3){
                                if (_loc_6 == 6){
                                    this.XAxisLifeLabels = this.createLabel("   " + String(24.9) + "                ", 16, 16777215);
                                }
                                else if (_loc_6 == 7){
                                    this.XAxisLifeLabels = this.createLabel(String(249.1), 16, 16777215);
                                }
                                else{
                                    this.XAxisLifeLabels = this.createLabel(this.decToSciMinusExp(_loc_8).substr(0, 11) + "<Font Face= \'Century Gothic Superscript\'>" + this.decToExp(_loc_8) + "</Font>", 16, 16777215);
                                }
                                this.XAxisLifeLabels.y = 540;
                                this.XAxisLifeLabels.x = this.returnLifeXY(_loc_8).x - 15;
                                this.XAxisLabelHolder.addChild(this.XAxisLifeLabels);
                            }
                        }
                        _loc_6++;
                    }
                    this.tickmarksX.x = 17;
                    this.tickmarksX.y = this.graphHeight;
                    this.tickmarksX.graphics.endFill();
                    this.XAxisTickmarckHolder.addChild(this.tickmarksX);
                    break;
                }
                case "Mass":{
                    this.clearObject(this.XAxisLabelHolder);
                    this.XAxisMinLabel = this.createLabel(String(this.minMass), 16, 16777215);
                    this.XAxisMinLabel.y = 540;
                    this.XAxisMinLabel.x = -10;
                    this.XAxisLabelHolder.addChild(this.XAxisMinLabel);
                    this.XAxisUnitLabel = this.createLabel("Solar Masses", 18, 16777215);
                    this.XAxisUnitLabel.y = 570;
                    this.XAxisUnitLabel.x = 240;
                    this.XAxisLabelHolder.addChild(this.XAxisUnitLabel);
                    this.tickmarksX.graphics.clear();
                    this.tickmarksX.graphics.beginFill(16777215);
                    this.tickmarksX.graphics.lineStyle(2, 16777215);
                    _loc_9 = 0;
                    while (_loc_9 < 7){
                        // label
                        if (_loc_9 != 0){
                            this.tickmarksX.graphics.moveTo(this.returnMassXY(5 * _loc_9).x, 5);
                            this.tickmarksX.graphics.lineTo(this.returnMassXY(5 * _loc_9).x, -5);
                            this.XAxisMassLabels = this.createLabel(String(5 * _loc_9), 16, 16777215);
                            this.XAxisMassLabels.y = 540;
                            this.XAxisMassLabels.x = this.returnMassXY(5 * _loc_9).x - 10;
                            this.XAxisLabelHolder.addChild(this.XAxisMassLabels);
                        }
                        _loc_9++;
                    }
                    this.tickmarksX.x = 0;
                    this.tickmarksX.y = this.graphHeight;
                    this.tickmarksX.graphics.endFill();
                    this.XAxisTickmarckHolder.addChild(this.tickmarksX);
                    break;
                }
                default:{
                    break;
                }
            }
            return;
        }
        public function clearObject(param1:Sprite) {
            var _loc_2:int;
            if (param1.numChildren != 0){
                _loc_2 = param1.numChildren;
                while (_loc_2--){
                    // label
                    param1.removeChildAt(_loc_2);
                }
            }
            return;
        }
        private function createLabel(param1:String, param2:int, param3:uint) : TextField {
            var _loc_4:* = new TextFormat();
            new TextFormat().font = "Century Gothic";
            _loc_4.color = param3;
            _loc_4.size = param2;
            var _loc_5:* = new TextField();
            new TextField().defaultTextFormat = _loc_4;
            _loc_5.autoSize = TextFieldAutoSize.LEFT;
            _loc_5.htmlText = param1;
            return _loc_5;
        }
        private function log(param1:Number) : Number {
            var _loc_2:Number;
            _loc_2 = Math.log(param1) / Math.log(10);
            return _loc_2;
        }
        private function decToSci(param1:Number) : Array {
            var _loc_2:* = new Array();
            var _loc_3:Number;
            var _loc_4:String;
            var _loc_5:* = Math.abs(param1);
            var _loc_6:* = Math.abs(param1) == param1 ? ("") : ("-");
            if (_loc_5 > 10){
                while (_loc_5 >= 10){
                    // label
                    _loc_5 = _loc_5 / 10;
                }
                _loc_4 = _loc_6 + String(_loc_5).substr(0, 5) + " x10";
                _loc_2.push(_loc_4, _loc_3++);
                return _loc_2;
            }
            else if (_loc_5 < 1){
                while (_loc_5 < 1){
                    // label
                    _loc_5 = _loc_5 * 10;
                }
                _loc_4 = _loc_6 + String(_loc_5).substr(0, 5) + " x10";
                _loc_2.push(_loc_4, _loc_3--);
                return _loc_2;
            }
            else{
                _loc_4 = _loc_6 + param1;
                _loc_2.push(_loc_4, _loc_3);
                return _loc_2;
            }
        }
        private function decToSciMinusExp(param1:Number) : String {
            var _loc_2:* = new Array();
            var _loc_3:String;
            var _loc_4:* = Math.abs(param1);
            var _loc_5:* = Math.abs(param1) == param1 ? ("") : ("-");
            if (_loc_4 > 10){
                while (_loc_4 >= 10){
                    // label
                    _loc_4 = _loc_4 / 10;
                }
                _loc_3 = _loc_5 + String(_loc_4).substr(0, 5) + " x10";
                _loc_2.push(_loc_3);
                return _loc_3;
            }
            else if (_loc_4 < 1){
                while (_loc_4 < 1){
                    // label
                    _loc_4 = _loc_4 * 10;
                }
                _loc_3 = _loc_5 + String(_loc_4).substr(0, 5) + " x10";
                _loc_2.push(_loc_3);
                return _loc_3;
            }
            else{
                _loc_3 = _loc_5 + param1;
                _loc_2.push(_loc_3);
                return _loc_3;
            }
        }
        private function decToExp(param1:Number) : String {
            var _loc_2:Number;
            var _loc_3:String;
            var _loc_4:* = Math.abs(param1);
            var _loc_5:* = Math.abs(param1) == param1 ? ("") : ("-");
            if (_loc_4 > 10){
                while (_loc_4 >= 10){
                    // label
                    _loc_4 = _loc_4 / 10;
                }
                _loc_3 = _loc_5 + String(_loc_4).substr(0, 5) + " x10";
                return String(_loc_2++);
            }
            else if (_loc_4 < 1){
                while (_loc_4 < 1){
                    // label
                    _loc_4 = _loc_4 * 10;
                }
                _loc_3 = _loc_5 + String(_loc_4).substr(0, 5) + " x10";
                return String(_loc_2--);
            }
            else{
                _loc_3 = _loc_5 + param1;
                return String(_loc_2);
            }
        }
        public function startDragHandler(param1:Event) {
            param1.target.parent.startDrag();
            return;
        }
        public function stopDragHandler(param1:Event) {
            param1.target.parent.stopDrag();
            return;
        }
        private function showMass(param1:Event) {
            this.clearObject(this.MassLabelHolder);
            this.MassLabelHolder.mouseEnabled = false;
            this.MassLabelHolder.mouseChildren = false;
            param1.target.parent.addChild(this.MassLabelHolder);
            this.MassLabel.multiline = true;
            this.MassLabelHolder.y = param1.target.y + 5;
            this.MassLabelHolder.x = param1.target.x + 5;
            this.MassLabelHolder.filters = new Array(this.glowFilter);
            if (param1.target.luminosity < 10 && param1.target.luminosity > 0 || param1.target.lifetime < 10 && param1.target.lifetime > 0){
                if (param1.target.luminosity < 10 && param1.target.luminosity > 0 && param1.target.lifetime < 10 && param1.target.lifetime > 0){
                    this.MassLabel = this.createLabel("Mass: " + String(param1.target.mass).substr(0, 4) + "\n" + "Luminosity: " + this.decToSciMinusExp(param1.target.luminosity).substr(0, 5) + "\n" + "Lifetime: " + this.decToSciMinusExp(param1.target.lifetime).substr(0, 5), 13, 65280);
                }
                else if (param1.target.luminosity < 10 && param1.target.luminosity > 0){
                    this.MassLabel = this.createLabel("Mass: " + String(param1.target.mass).substr(0, 4) + "\n" + "Luminosity: " + this.decToSciMinusExp(param1.target.luminosity).substr(0, 5) + "\n" + "Lifetime: " + this.decToSciMinusExp(param1.target.lifetime) + "<font face=\'Century Gothic Superscript\'> " + this.decToExp(param1.target.lifetime) + "</font>", 13, 65280);
                }
                else{
                    this.MassLabel = this.createLabel("Mass: " + String(param1.target.mass).substr(0, 4) + "\n" + "Luminosity: " + this.decToSciMinusExp(param1.target.luminosity) + "<font face=\'Century Gothic Superscript\'> " + this.decToExp(param1.target.luminosity) + "</font>" + "\n" + "Lifetime: " + this.decToSciMinusExp(param1.target.lifetime).substr(0, 5), 13, 65280);
                }
            }
            else{
                this.MassLabel = this.createLabel("Mass: " + String(param1.target.mass).substr(0, 4) + "\n" + "Luminosity: " + this.decToSciMinusExp(param1.target.luminosity) + "<font face=\'Century Gothic Superscript\'> " + this.decToExp(param1.target.luminosity) + "</font>" + "\n" + "Lifetime: " + this.decToSciMinusExp(param1.target.lifetime) + "<font face=\'Century Gothic Superscript\'> " + this.decToExp(param1.target.lifetime) + "</font>", 13, 65280);
            }
            this.MassLabelHolder.addChild(this.MassLabel);
            return;
        }
        private function hideMass(param1:Event) {
            this.clearObject(this.MassLabelHolder);
            return;
        }
        private function returnMassXY(param1:Number) : Point {
            var _loc_2:* = new Point();
            _loc_2.y = this.graphHeight - (param1 - this.minMass) / (this.maxMass - this.minMass) * this.graphHeight;
            _loc_2.x = (param1 - this.minMass) / (this.maxMass - this.minMass) * this.graphWidth;
            return _loc_2;
        }
        private function returnLumXY(param1:Number) : Point {
            var _loc_2:* = new Point();
            _loc_2.y = this.graphHeight - (param1 - this.minLuminosity) / (this.maxLuminosity - this.minLuminosity) * this.graphHeight;
            _loc_2.x = (param1 - this.minLuminosity) / (this.maxLuminosity - this.minLuminosity) * this.graphWidth;
            return _loc_2;
        }
        private function returnLifeXY(param1:Number) : Point {
            var _loc_2:* = new Point();
            _loc_2.x = (this.log(param1) - this.log(this.minLifetime)) / (this.log(this.maxLifetime) - this.log(this.minLifetime));
            _loc_2.y = (this.log(param1) - this.log(this.minLifetime)) / (this.log(this.maxLifetime) - this.log(this.minLifetime));
            _loc_2.y = this.graphHeight - _loc_2.y * this.graphHeight;
            _loc_2.x = _loc_2.x * this.graphWidth;
            trace(_loc_2);
            return _loc_2;
        }
        private function returnMassTicmarckY(param1:Number) : Number {
            var _loc_2:Number;
            _loc_2 = (param1 - this.minMass) / (this.maxMass - this.minMass) * this.graphHeight;
            return _loc_2;
        }
        private function returnLumTicmarckY(param1:Number) : Number {
            var _loc_2:Number;
            _loc_2 = (param1 - this.minLuminosity) / (this.maxLuminosity - this.minLuminosity) * this.log(10 * ((param1 - this.minLuminosity) / (this.maxLuminosity - this.minLuminosity))) * this.graphHeight;
            return _loc_2;
        }
        private function returnLifeTicmarckY(param1:Number) : Number {
            var _loc_2:Number;
            _loc_2 = (this.log(param1) - this.log(this.minLifetime)) / (this.log(this.maxLifetime) - this.log(this.minLifetime));
            _loc_2 = _loc_2 * this.graphHeight;
            return _loc_2;
        }
    }
}
