﻿package  {
	
	//IMPORT STATEMENTS
	import flash.events.Event;
	import flash.filters.GlowFilter;

	public class StarManager
	{
		//CLASS VARIABLES
		public var targetStarBox : StarBox;
		public var glowFilter:GlowFilter = new GlowFilter(0xffffff,0.75,12,12);
		public var selectedStars:Array = new Array ();
		
		public function StarManager(_targetStarBox:StarBox)
		{
			targetStarBox =  _targetStarBox;
		}
		public function selectStar(event:Event)
		{
			if (selectedStars.indexOf(event.target) == -1)
			{
				event.target.filters = new Array(glowFilter);
				selectedStars.push(event.target);
				trace(event.target);
				var starInfo:String = "Mass: " + String(event.target.mass).substr(0,4);
				starInfo +=  " Life: " + decToSci(event.target.lifetime).substr(0,11);
				starInfo +=  " Lumin: " + decToSci(event.target.luminosity).substr(0,11);
				targetStarBox.ListArray.push(starInfo);
				targetStarBox.initList();
			}
		}
		public function addStar (newStar:Object) {
			if (selectedStars.indexOf(newStar) == -1)
			{
				newStar.filters = new Array(glowFilter);
				selectedStars.push(newStar);
				var starInfo:String = "Mass: " + String(newStar.mass).substr(0,4);
				starInfo +=  " Life: " + decToSci(newStar.lifetime).substr(0,11);
				starInfo +=  " Lumin: " + decToSci(newStar.luminosity).substr(0,11);
				targetStarBox.ListArray.push(starInfo);
				targetStarBox.initList();
			}
		}
		private function decToSci(decimal:Number):String
		{
			var timelineLabels:Array = new Array ();
			var count:Number = 0;
			var result:String = "0";
			var posDecimal:Number = Math.abs(decimal);
			var sign:String = posDecimal == decimal ? "":"-";
			if (posDecimal > 10)
			{
				while (posDecimal >= 10)
				{
					posDecimal /=  10;
					count++;
				}
				result = sign + String(posDecimal).substr(0,5) + " x10^"+count;
				timelineLabels.push(result);
				return result;
			}
			else if (posDecimal < 1)
			{
				while (posDecimal < 1)
				{
					posDecimal *=  10;
					count--;
				}
				result = sign + String(posDecimal).substr(0,5) + " x10^"+count;
				timelineLabels.push(result);
				return result;
			}
			else
			{
				result = sign + decimal;
				timelineLabels.push(result);
				return result;
			}
		}
	}
}
