﻿package  {
	
	//IMPORT STATEMENTS
	import flash.events.Event;
	import flash.display.Sprite;
	import flash.text.TextField;
	import flash.events.MouseEvent;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.display.MovieClip;
	import fl.controls.Slider;
	import fl.controls.Button;
	
	public class Timeline extends MovieClip
	{
		//CLASS VARIABLES
		public var timelineLabelHolder:Sprite;
		public var timelineLabel:TextField;
		public var timelineExponentField:TextField;
		public var currentTime:Number;
		public var targetTimeline:Slider;
		public var animationControler:Button;
		public var targetTimelineLabelHolder:Sprite;
		public var targetStellarArray:Array;
		
		public function Timeline(_targetTimeline:Slider,_animationControler:Button,_timelineLabelHolder:Sprite,_stellarArray:Array)
		{
			animationControler = _animationControler;
			targetTimeline = _targetTimeline;
			targetTimelineLabelHolder = _timelineLabelHolder;
			targetStellarArray = _stellarArray;
		}		
		public function frameHandler(event:Event)
		{
			targetTimeline.value = targetTimeline.value + 2;
			clearObject(targetTimelineLabelHolder);
			currentTime = timeLineValue(targetTimeline.value);

			//CREATING THE MAIN TIMELINE LABEL
			timelineLabel = createLabel(decToSci(currentTime)[0] + "   Years",16,0xFFFFFF);
			timelineLabel.x = 480;
			timelineLabel.y = 570;
			targetTimelineLabelHolder.addChild(timelineLabel);

			//CREATING THE EXPONENT;
			timelineExponentField = createLabel(decToSci(currentTime)[1],11,0xFFFFFF);
			timelineExponentField.x = 552;
			timelineExponentField.y = 560;
			targetTimelineLabelHolder.addChild(timelineExponentField);

			for (var i: int =0; i < targetStellarArray.length; i++)
			{
				if (targetStellarArray[i].lifetime < currentTime && targetStellarArray[i].destroyed == false)
				{					
					targetStellarArray[i].destroyed = true;
					targetStellarArray[i].gotoAndPlay(1);
				}
			}
		}
		private function timeLineValue(V:Number):Number
		{
			const tMin:Number = 1.8 * Math.pow(10,6);
			const tMax:Number = 2.8 * Math.pow(10,12);
			const VMax:Number = 2880;
			return (V/VMax)*(tMax - tMin)* log(1+V/VMax*1/10)+tMin;
		}
		public function stopEventListener()
		{
			this.removeEventListener(Event.ENTER_FRAME,frameHandler);
		}
		public function playAnimation(event:Event)
		{
			this.addEventListener(Event.ENTER_FRAME, frameHandler);
			animationControler.label = "Pause";
			animationControler.removeEventListener(MouseEvent.CLICK, playAnimation);
			animationControler.addEventListener(MouseEvent.CLICK, pauseAnimation);
			for (var i: int =0; i < targetStellarArray.length; i++)
			{
				//targetStellarArray[i].mouseEnabled = false;
			}
		}
		public function pauseAnimation(event:Event)
		{
			this.removeEventListener(Event.ENTER_FRAME, frameHandler);
			animationControler.label = "Play";
			animationControler.removeEventListener(MouseEvent.CLICK, pauseAnimation);
			animationControler.addEventListener(MouseEvent.CLICK, playAnimation);
			for (var i: int =0; i < targetStellarArray.length; i++)
			{
				//targetStellarArray[i].mouseEnabled = true;
			}
		}
		public function clearObject(object:Sprite)
		{
			if (object.numChildren != 0)
			{
				var i:int = object.numChildren;
				while (i--)
				{
					object.removeChildAt(i);
				}
			}
		}
		private function createLabel(labelText:String, size:int, color:uint):TextField
		{
			var textLabelFormat:TextFormat = new TextFormat();
			textLabelFormat.font = "Century Gothic";
			textLabelFormat.color = color;
			textLabelFormat.size = size;
			var textLabel:TextField = new TextField();
			textLabel.defaultTextFormat = textLabelFormat;
			textLabel.autoSize = TextFieldAutoSize.LEFT;
			textLabel.text = labelText;
			return textLabel;
		}
		private function log(number:Number):Number
		{
			var Answer:Number;
			Answer = Math.log(number) / Math.log(10);
			return Answer;
		}
		private function decToSci(decimal:Number):Array
		{
			var timelineLabels:Array = new Array ();
			var count:Number = 0;
			var result:String = "0";
			var posDecimal:Number = Math.abs(decimal);
			var sign:String = posDecimal == decimal ? "":"-";
			if (posDecimal > 10)
			{
				while (posDecimal >= 10)
				{
					posDecimal /=  10;
					count++;
				}
				result = sign + String(posDecimal).substr(0,5) + " x10";
				timelineLabels.push(result,count);
				return timelineLabels;
			}
			else if (posDecimal < 1)
			{
				while (posDecimal < 1)
				{
					posDecimal *=  10;
					count--;
				}
				result = sign + String(posDecimal).substr(0,5) + " x10";
				timelineLabels.push(result,count);
				return timelineLabels;
			}
			else
			{
				result = sign + decimal;
				timelineLabels.push(result,count);
				return timelineLabels;
			}
		}
	}
}
